OK, I can reproduce the problem using a very simple code ( with no complicated geometry from another drawing).
This is just a L shape PolyFaceMesh, and yet I can reproduce the problem.

Here's the code:
[CommandMethod(nameof(LShapeAddFromPolyFace))]
public void LShapeAddFromPolyFace()
{
try
{
using (var ts = ActiveACADDocument.TransactionManager.StartTransaction())
{
var surfaceId2 = TinSurface.Create(ActiveACADDocument.Database, "FromMeshTest");
var platformSurface = ts.GetObject(surfaceId2, OpenMode.ForWrite) as TinSurface;
var bt = (BlockTable)ts.GetObject(ActiveACADDocument.Database.BlockTableId, OpenMode.ForRead, false);
var btr = (BlockTableRecord)ts.GetObject(bt[BlockTableRecord.ModelSpace], OpenMode.ForWrite, false);
var vertices = platformSurface.Vertices;
if (vertices.Count != 0)
{
platformSurface.DeleteVertices(vertices);
}
var polyMesh = new PolyFaceMesh();
polyMesh.SetDatabaseDefaults();
btr.AppendEntity(polyMesh);
ts.AddNewlyCreatedDBObject(polyMesh, true);
var vertex1 = new PolyFaceMeshVertex(new Point3d(0, 0, 0));
polyMesh.AppendVertex(vertex1);
ts.AddNewlyCreatedDBObject(vertex1, true);
var vertex2 = new PolyFaceMeshVertex(new Point3d(10, 0, 0));
polyMesh.AppendVertex(vertex2);
ts.AddNewlyCreatedDBObject(vertex2, true);
var vertex3 = new PolyFaceMeshVertex(new Point3d(10, 10, 0));
polyMesh.AppendVertex(vertex3);
ts.AddNewlyCreatedDBObject(vertex3, true);
var vertex4 = new PolyFaceMeshVertex(new Point3d(0, 10, 0));
polyMesh.AppendVertex(vertex4);
ts.AddNewlyCreatedDBObject(vertex4, true);
var vertex5 =new PolyFaceMeshVertex(new Point3d(5, 10, 0));
polyMesh.AppendVertex(vertex5);
ts.AddNewlyCreatedDBObject(vertex5, true);
var vertex6 = new PolyFaceMeshVertex(new Point3d(10, 10, 0));
polyMesh.AppendVertex(vertex6);
ts.AddNewlyCreatedDBObject(vertex6, true);
var vertex7 =new PolyFaceMeshVertex(new Point3d(10, 20, 0));
polyMesh.AppendVertex(vertex7);
ts.AddNewlyCreatedDBObject(vertex7, true);
var vertex8 =new PolyFaceMeshVertex(new Point3d(5, 20, 0));
polyMesh.AppendVertex(vertex8);
ts.AddNewlyCreatedDBObject(vertex8, true);
var fr1 = new FaceRecord(1, 2, 3, 0);
polyMesh.AppendFaceRecord(fr1);
ts.AddNewlyCreatedDBObject(fr1, true);
var fr2 = new FaceRecord(1, 3, 4, 0);
polyMesh.AppendFaceRecord(fr2);
ts.AddNewlyCreatedDBObject(fr2, true);
var fr3 = new FaceRecord(5,6,7, 0);
polyMesh.AppendFaceRecord(fr3);
ts.AddNewlyCreatedDBObject(fr3, true);
var fr4 = new FaceRecord(5, 7, 8, 0);
polyMesh.AppendFaceRecord(fr4);
ts.AddNewlyCreatedDBObject(fr4, true);
platformSurface.DrawingObjectsDefinition.AddFromPolyFaces(new ObjectIdCollection(new[] { polyMesh.Id }),
true, $"Normal Platform");
var spuriousEdges = platformSurface.GetEdges().Where(ee => !ee.IsLocked).ToList();
if (spuriousEdges.Count > 0)
{
platformSurface.DeleteLines(spuriousEdges);
}
platformSurface.Rebuild();
ACADEditor.ZoomExtents();
ts.Commit();
}
}
catch (System.Exception e)
{
MessageBox.Show(e.ToString());
}
}
Maybe it's how I use the IsLocked filter to delete the spurious edge? But if I don't do it, then my TinSurface will be bigger than the PolyFace mesh!
##########
Ngu Soon Hui##########
I'm the Benevolent Dictator for Life for
MiTS Software. Read more
here I also setup
Civil WHIZ in order to share what I learnt about Civil 3D